/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the ChannelPermissionPermissions type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ChannelPermissionPermissions{}

// ChannelPermissionPermissions struct for ChannelPermissionPermissions
type ChannelPermissionPermissions struct {
	// Available permissions list:   PermissionDenied  Permission = 0    PermissionRead    Permission = 1     PermissionWrite   Permission = 2    PermissionExecute Permission = 4    PermissionDelete  Permission = 8   Permissions can be combined
	Contacts *int32 `json:"contacts,omitempty"`
	// Available permissions list:   PermissionDenied  Permission = 0    PermissionRead    Permission = 1     PermissionWrite   Permission = 2    PermissionExecute Permission = 4    PermissionDelete  Permission = 8   Permissions can be combined
	Conversations *int32 `json:"conversations,omitempty"`
	// Available permissions list:   PermissionDenied  Permission = 0    PermissionRead    Permission = 1     PermissionWrite   Permission = 2    PermissionExecute Permission = 4    PermissionDelete  Permission = 8   Permissions can be combined
	Locations *int32 `json:"locations,omitempty"`
	// Available permissions list:   PermissionDenied  Permission = 0    PermissionRead    Permission = 1     PermissionWrite   Permission = 2    PermissionExecute Permission = 4    PermissionDelete  Permission = 8   Permissions can be combined
	Gateways *int32 `json:"gateways,omitempty"`
	// Available permissions list:   PermissionDenied  Permission = 0    PermissionRead    Permission = 1     PermissionWrite   Permission = 2    PermissionExecute Permission = 4    PermissionDelete  Permission = 8   Permissions can be combined
	Organizations *int32 `json:"organizations,omitempty"`
	// Available permissions list:   PermissionDenied  Permission = 0    PermissionRead    Permission = 1     PermissionWrite   Permission = 2    PermissionExecute Permission = 4    PermissionDelete  Permission = 8   Permissions can be combined
	Channels *int32 `json:"channels,omitempty"`
	// Available permissions list:   PermissionDenied  Permission = 0    PermissionRead    Permission = 1     PermissionWrite   Permission = 2    PermissionExecute Permission = 4    PermissionDelete  Permission = 8   Permissions can be combined
	Events *int32 `json:"events,omitempty"`
	// Available permissions list:   PermissionDenied  Permission = 0    PermissionRead    Permission = 1     PermissionWrite   Permission = 2    PermissionExecute Permission = 4    PermissionDelete  Permission = 8   Permissions can be combined
	Templates *int32 `json:"templates,omitempty"`
	// Available permissions list:   PermissionDenied  Permission = 0    PermissionRead    Permission = 1     PermissionWrite   Permission = 2    PermissionExecute Permission = 4    PermissionDelete  Permission = 8   Permissions can be combined
	Campaigns *int32 `json:"campaigns,omitempty"`
	// Available permissions list:   PermissionDenied  Permission = 0    PermissionRead    Permission = 1     PermissionWrite   Permission = 2    PermissionExecute Permission = 4    PermissionDelete  Permission = 8   Permissions can be combined
	Users *int32 `json:"users,omitempty"`
}

// NewChannelPermissionPermissions instantiates a new ChannelPermissionPermissions object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewChannelPermissionPermissions() *ChannelPermissionPermissions {
	this := ChannelPermissionPermissions{}
	return &this
}

// NewChannelPermissionPermissionsWithDefaults instantiates a new ChannelPermissionPermissions object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewChannelPermissionPermissionsWithDefaults() *ChannelPermissionPermissions {
	this := ChannelPermissionPermissions{}
	return &this
}

// GetContacts returns the Contacts field value if set, zero value otherwise.
func (o *ChannelPermissionPermissions) GetContacts() int32 {
	if o == nil || IsNil(o.Contacts) {
		var ret int32
		return ret
	}
	return *o.Contacts
}

// GetContactsOk returns a tuple with the Contacts field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelPermissionPermissions) GetContactsOk() (*int32, bool) {
	if o == nil || IsNil(o.Contacts) {
		return nil, false
	}
	return o.Contacts, true
}

// HasContacts returns a boolean if a field has been set.
func (o *ChannelPermissionPermissions) HasContacts() bool {
	if o != nil && !IsNil(o.Contacts) {
		return true
	}

	return false
}

// SetContacts gets a reference to the given int32 and assigns it to the Contacts field.
func (o *ChannelPermissionPermissions) SetContacts(v int32) {
	o.Contacts = &v
}

// GetConversations returns the Conversations field value if set, zero value otherwise.
func (o *ChannelPermissionPermissions) GetConversations() int32 {
	if o == nil || IsNil(o.Conversations) {
		var ret int32
		return ret
	}
	return *o.Conversations
}

// GetConversationsOk returns a tuple with the Conversations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelPermissionPermissions) GetConversationsOk() (*int32, bool) {
	if o == nil || IsNil(o.Conversations) {
		return nil, false
	}
	return o.Conversations, true
}

// HasConversations returns a boolean if a field has been set.
func (o *ChannelPermissionPermissions) HasConversations() bool {
	if o != nil && !IsNil(o.Conversations) {
		return true
	}

	return false
}

// SetConversations gets a reference to the given int32 and assigns it to the Conversations field.
func (o *ChannelPermissionPermissions) SetConversations(v int32) {
	o.Conversations = &v
}

// GetLocations returns the Locations field value if set, zero value otherwise.
func (o *ChannelPermissionPermissions) GetLocations() int32 {
	if o == nil || IsNil(o.Locations) {
		var ret int32
		return ret
	}
	return *o.Locations
}

// GetLocationsOk returns a tuple with the Locations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelPermissionPermissions) GetLocationsOk() (*int32, bool) {
	if o == nil || IsNil(o.Locations) {
		return nil, false
	}
	return o.Locations, true
}

// HasLocations returns a boolean if a field has been set.
func (o *ChannelPermissionPermissions) HasLocations() bool {
	if o != nil && !IsNil(o.Locations) {
		return true
	}

	return false
}

// SetLocations gets a reference to the given int32 and assigns it to the Locations field.
func (o *ChannelPermissionPermissions) SetLocations(v int32) {
	o.Locations = &v
}

// GetGateways returns the Gateways field value if set, zero value otherwise.
func (o *ChannelPermissionPermissions) GetGateways() int32 {
	if o == nil || IsNil(o.Gateways) {
		var ret int32
		return ret
	}
	return *o.Gateways
}

// GetGatewaysOk returns a tuple with the Gateways field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelPermissionPermissions) GetGatewaysOk() (*int32, bool) {
	if o == nil || IsNil(o.Gateways) {
		return nil, false
	}
	return o.Gateways, true
}

// HasGateways returns a boolean if a field has been set.
func (o *ChannelPermissionPermissions) HasGateways() bool {
	if o != nil && !IsNil(o.Gateways) {
		return true
	}

	return false
}

// SetGateways gets a reference to the given int32 and assigns it to the Gateways field.
func (o *ChannelPermissionPermissions) SetGateways(v int32) {
	o.Gateways = &v
}

// GetOrganizations returns the Organizations field value if set, zero value otherwise.
func (o *ChannelPermissionPermissions) GetOrganizations() int32 {
	if o == nil || IsNil(o.Organizations) {
		var ret int32
		return ret
	}
	return *o.Organizations
}

// GetOrganizationsOk returns a tuple with the Organizations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelPermissionPermissions) GetOrganizationsOk() (*int32, bool) {
	if o == nil || IsNil(o.Organizations) {
		return nil, false
	}
	return o.Organizations, true
}

// HasOrganizations returns a boolean if a field has been set.
func (o *ChannelPermissionPermissions) HasOrganizations() bool {
	if o != nil && !IsNil(o.Organizations) {
		return true
	}

	return false
}

// SetOrganizations gets a reference to the given int32 and assigns it to the Organizations field.
func (o *ChannelPermissionPermissions) SetOrganizations(v int32) {
	o.Organizations = &v
}

// GetChannels returns the Channels field value if set, zero value otherwise.
func (o *ChannelPermissionPermissions) GetChannels() int32 {
	if o == nil || IsNil(o.Channels) {
		var ret int32
		return ret
	}
	return *o.Channels
}

// GetChannelsOk returns a tuple with the Channels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelPermissionPermissions) GetChannelsOk() (*int32, bool) {
	if o == nil || IsNil(o.Channels) {
		return nil, false
	}
	return o.Channels, true
}

// HasChannels returns a boolean if a field has been set.
func (o *ChannelPermissionPermissions) HasChannels() bool {
	if o != nil && !IsNil(o.Channels) {
		return true
	}

	return false
}

// SetChannels gets a reference to the given int32 and assigns it to the Channels field.
func (o *ChannelPermissionPermissions) SetChannels(v int32) {
	o.Channels = &v
}

// GetEvents returns the Events field value if set, zero value otherwise.
func (o *ChannelPermissionPermissions) GetEvents() int32 {
	if o == nil || IsNil(o.Events) {
		var ret int32
		return ret
	}
	return *o.Events
}

// GetEventsOk returns a tuple with the Events field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelPermissionPermissions) GetEventsOk() (*int32, bool) {
	if o == nil || IsNil(o.Events) {
		return nil, false
	}
	return o.Events, true
}

// HasEvents returns a boolean if a field has been set.
func (o *ChannelPermissionPermissions) HasEvents() bool {
	if o != nil && !IsNil(o.Events) {
		return true
	}

	return false
}

// SetEvents gets a reference to the given int32 and assigns it to the Events field.
func (o *ChannelPermissionPermissions) SetEvents(v int32) {
	o.Events = &v
}

// GetTemplates returns the Templates field value if set, zero value otherwise.
func (o *ChannelPermissionPermissions) GetTemplates() int32 {
	if o == nil || IsNil(o.Templates) {
		var ret int32
		return ret
	}
	return *o.Templates
}

// GetTemplatesOk returns a tuple with the Templates field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelPermissionPermissions) GetTemplatesOk() (*int32, bool) {
	if o == nil || IsNil(o.Templates) {
		return nil, false
	}
	return o.Templates, true
}

// HasTemplates returns a boolean if a field has been set.
func (o *ChannelPermissionPermissions) HasTemplates() bool {
	if o != nil && !IsNil(o.Templates) {
		return true
	}

	return false
}

// SetTemplates gets a reference to the given int32 and assigns it to the Templates field.
func (o *ChannelPermissionPermissions) SetTemplates(v int32) {
	o.Templates = &v
}

// GetCampaigns returns the Campaigns field value if set, zero value otherwise.
func (o *ChannelPermissionPermissions) GetCampaigns() int32 {
	if o == nil || IsNil(o.Campaigns) {
		var ret int32
		return ret
	}
	return *o.Campaigns
}

// GetCampaignsOk returns a tuple with the Campaigns field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelPermissionPermissions) GetCampaignsOk() (*int32, bool) {
	if o == nil || IsNil(o.Campaigns) {
		return nil, false
	}
	return o.Campaigns, true
}

// HasCampaigns returns a boolean if a field has been set.
func (o *ChannelPermissionPermissions) HasCampaigns() bool {
	if o != nil && !IsNil(o.Campaigns) {
		return true
	}

	return false
}

// SetCampaigns gets a reference to the given int32 and assigns it to the Campaigns field.
func (o *ChannelPermissionPermissions) SetCampaigns(v int32) {
	o.Campaigns = &v
}

// GetUsers returns the Users field value if set, zero value otherwise.
func (o *ChannelPermissionPermissions) GetUsers() int32 {
	if o == nil || IsNil(o.Users) {
		var ret int32
		return ret
	}
	return *o.Users
}

// GetUsersOk returns a tuple with the Users field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelPermissionPermissions) GetUsersOk() (*int32, bool) {
	if o == nil || IsNil(o.Users) {
		return nil, false
	}
	return o.Users, true
}

// HasUsers returns a boolean if a field has been set.
func (o *ChannelPermissionPermissions) HasUsers() bool {
	if o != nil && !IsNil(o.Users) {
		return true
	}

	return false
}

// SetUsers gets a reference to the given int32 and assigns it to the Users field.
func (o *ChannelPermissionPermissions) SetUsers(v int32) {
	o.Users = &v
}

func (o ChannelPermissionPermissions) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ChannelPermissionPermissions) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Contacts) {
		toSerialize["contacts"] = o.Contacts
	}
	if !IsNil(o.Conversations) {
		toSerialize["conversations"] = o.Conversations
	}
	if !IsNil(o.Locations) {
		toSerialize["locations"] = o.Locations
	}
	if !IsNil(o.Gateways) {
		toSerialize["gateways"] = o.Gateways
	}
	if !IsNil(o.Organizations) {
		toSerialize["organizations"] = o.Organizations
	}
	if !IsNil(o.Channels) {
		toSerialize["channels"] = o.Channels
	}
	if !IsNil(o.Events) {
		toSerialize["events"] = o.Events
	}
	if !IsNil(o.Templates) {
		toSerialize["templates"] = o.Templates
	}
	if !IsNil(o.Campaigns) {
		toSerialize["campaigns"] = o.Campaigns
	}
	if !IsNil(o.Users) {
		toSerialize["users"] = o.Users
	}
	return toSerialize, nil
}

type NullableChannelPermissionPermissions struct {
	value *ChannelPermissionPermissions
	isSet bool
}

func (v NullableChannelPermissionPermissions) Get() *ChannelPermissionPermissions {
	return v.value
}

func (v *NullableChannelPermissionPermissions) Set(val *ChannelPermissionPermissions) {
	v.value = val
	v.isSet = true
}

func (v NullableChannelPermissionPermissions) IsSet() bool {
	return v.isSet
}

func (v *NullableChannelPermissionPermissions) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableChannelPermissionPermissions(val *ChannelPermissionPermissions) *NullableChannelPermissionPermissions {
	return &NullableChannelPermissionPermissions{value: val, isSet: true}
}

func (v NullableChannelPermissionPermissions) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableChannelPermissionPermissions) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


